// -*- mode: js2; indent-tabs-mode: nil; js2-basic-offset: 4 -*-

const GObject = imports.gi.GObject;
const Gtk = imports.gi.Gtk;
const Lang = imports.lang;
const Gio = imports.gi.Gio;

const ExtensionUtils = imports.misc.extensionUtils;
const Me = ExtensionUtils.getCurrentExtension();
const Convenience = Me.imports.convenience;

function init() {}

const CurvySettings = new GObject.Class({
    Name: 'CurvyPrefs',
    Extends: Gtk.Grid,

    _init: function(params) {
        this.parent(params);
        this.margin = 72;
        this.margin_top = 32;
        this.margin_bottom = 32;
        this._settings = Convenience.getSettings();

        let label = null;
        let spin = null;
        this.scale = null;
        let value = null;

        // Corner size Label
        label = new Gtk.Label({
            label: 'Corner size (px)',
            hexpand: true,
            halign: Gtk.Align.START
        });

        // Corner size SpinButton
        spin = new Gtk.SpinButton({halign:Gtk.Align.END});
        spin.set_sensitive(true);
        spin.set_range(0, 200);
        spin.set_value(this._settings.get_int('corner-size'));
        spin.set_increments(1, 2);

        spin.connect('value-changed', Lang.bind(this, function(w){
            value = w.get_value_as_int();
            this._settings.set_int('corner-size', value);
         }));

        // Corner size Scale... need to mess with this more.
        /*scale = new Gtk.Scale({
            valign: Gtk.Align.BASELINE,
            hexpand: true,
            value_pos: Gtk.PositionType.RIGHT,
            round_digits: 1,
            digits: 0,
        });

        scale.add_mark(8, Gtk.PositionType.TOP, '8');
        scale.add_mark(12, Gtk.PositionType.TOP, '12');
        scale.add_mark(16, Gtk.PositionType.TOP, '16');
        scale.add_mark(24, Gtk.PositionType.TOP, '24');
        scale.add_mark(32, Gtk.PositionType.TOP, '32');
        scale.add_mark(48, Gtk.PositionType.TOP, '48');

        scale.set_range(0, 64);
        scale.set_value(this._settings.get_int('corner-size'));*/

        this.attach(label, 0, 1, 1, 1);
        this.attach(spin, 1, 1, 1, 1);
        //this.attach(scale, 1, 1, 10, 1);
    },

});

function buildPrefsWidget() {
     let widget = new CurvySettings();
     widget.show_all();

     return widget;
}
